<?php
/*
*  @ Version 1.0.0 Beta 2008-03-02
*  @ Simply Links
*  @ Joomla! 1.5.X
*  @ Author: Anh Dai
*  @ Email: info@nekkarcity.de
*  @ License - GPL
*/

// no direct access
defined('_JEXEC') or die();

jimport( 'joomla.application.component.controller' );

class SimplylinksController extends JController
{
	function __construct($config = array())
	{
		parent::__construct($config);

		// Register Extra tasks
		$this->registerTask( 'add',  'display' );
		$this->registerTask( 'edit', 'display' );
	}

	function display( )
	{
		switch($this->getTask())
		{
			case 'add'     :
			{
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'layout', 'form'  );
				JRequest::setVar( 'view'  , 'simplylink');
				JRequest::setVar( 'edit', false );

				// Checkout the simplylink
				$model = $this->getModel('simplylink');
				$model->checkout();
			} break;
			case 'edit'    :
			{
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'layout', 'form'  );
				JRequest::setVar( 'view'  , 'simplylink');
				JRequest::setVar( 'edit', true );

				// Checkout the simplylink
				$model = $this->getModel('simplylink');
				$model->checkout();
			} break;
		}

		parent::display();
	}

	function save()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );

		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];

		$model = $this->getModel('simplylink');

		if ($model->store($post)) {
			$msg = JText::_( 'Simplylink Saved' );
		} else {
			$msg = JText::_( 'Error Saving Simplylink' );
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();
		$link = 'index.php?option=com_simplylinks';
		$this->setRedirect($link, $msg);
	}

	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to delete' ) );
		}

		$model = $this->getModel('simplylink');
		if(!$model->delete($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_simplylinks' );
	}


	function publish()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$model = $this->getModel('simplylink');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_simplylinks' );
	}


	function unpublish()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}

		$model = $this->getModel('simplylink');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_simplylinks' );
	}

	function cancel()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );

		// Checkin the simplylink
		$model = $this->getModel('simplylink');
		$model->checkin();

		$this->setRedirect( 'index.php?option=com_simplylinks' );
	}


	function orderup()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );

		$model = $this->getModel('simplylink');
		$model->move(-1);

		$this->setRedirect( 'index.php?option=com_simplylinks');
	}

	function orderdown()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );

		$model = $this->getModel('simplylink');
		$model->move(1);

		$this->setRedirect( 'index.php?option=com_simplylinks');
	}

	function saveorder()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );

		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('simplylink');
		$model->saveorder($cid, $order);

		$msg = 'New ordering saved';
		$this->setRedirect( 'index.php?option=com_simplylinks', $msg );
	}
}