<?php
/*
*  @ Version 1.0.0 Beta 2008-03-02
*  @ Simply Links
*  @ Joomla! 1.5.X
*  @ Author: Anh Dai
*  @ Email: info@nekkarcity.de
*  @ License - GPL
*/

// no direct access
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view');

class SimplylinksViewSimplylink extends JView
{
	function display($tpl = null)
	{
		global $mainframe;

		if($this->getLayout() == 'form') {
			$this->_displayForm($tpl);
			return;
		}

		//get the simplylink
		$simplylink =& $this->get('data');

		if ($simplylink->url) {
			// redirects to url if matching id found
			$mainframe->redirect($simplylink->url);
		}

		parent::display($tpl);
	}

	function _displayForm($tpl)
	{
		global $mainframe, $option;

		$db		=& JFactory::getDBO();
		$uri 	=& JFactory::getURI();
		$user 	=& JFactory::getUser();
		$model	=& $this->getModel();


		$lists = array();

		//get the simplylink
		$simplylink	=& $this->get('data');
		$isNew		= ($simplylink->id < 1);

		// fail if checked out not by 'me'
		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The simplylink' ), $simplylink->title );
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}

		// Edit or Create?
		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
		}
		else
		{
			// initialise new record
			$simplylink->published = 1;
			$simplylink->approved 	= 1;
			$simplylink->order 	= 0;
			$simplylink->catid 	= JRequest::getVar( 'catid', 0, 'post', 'int' );
		}

		// build the html select list for ordering
		$query = 'SELECT ordering AS value, title AS text'
			. ' FROM #__simplylinks'
			. ' WHERE catid = ' . (int) $simplylink->catid
			. ' ORDER BY ordering';

		//$lists['ordering'] 			= JHTML::_('list.specificordering',  $simplylink, $simplylink->id, $query, 1 );

		// build list of categories
		$category = array();
		$category[] = JHTML::_('select.option','0','- Select a Category -');
		$category[] = JHTML::_('select.option','1', 'Glossary');
		$category[] = JHTML::_('select.option','2', 'Internal Link');
		$category[] = JHTML::_('select.option','5', 'External Link');
		
		$lists['catid'] = JHTML::_('select.genericlist', $category, 'catid', 'class="inputbox" size="1"', 'value', 'text', intval( $simplylink->catid ));
		
		// build the html select list
		$lists['published'] 		= JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $simplylink->published );

		//clean simplylink data
		JFilterOutput::objectHTMLSafe( $simplylink, ENT_QUOTES, 'description' );

		$this->assignRef('lists',		$lists);
		$this->assignRef('simplylink',		$simplylink);

		parent::display($tpl);
	}
}