<?php
/*
*  @ Version 1.0.0 Beta 2008-03-02
*  @ Simply Links
*  @ Joomla! 1.5.X
*  @ Author: Anh Dai
*  @ Email: info@nekkarcity.de
*  @ License - GPL
*/

// no direct access!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view');

class SimplylinksViewSimplylink extends JView
{
	function display($tpl = null)
	{
		global $mainframe;

		if($this->getLayout() == 'form') {
			$this->_displayForm($tpl);
			return;
		}

		//get the simplylink
		$simplylink =& $this->get('data');

		if ($simplylink->url) {
			// redirects to url if matching id found
			$mainframe->redirect($simplylink->url);
		}

		parent::display($tpl);
	}

	function _displayForm($tpl)
	{
		global $mainframe;

		// Get some objects from the JApplication
		$pathway	=& $mainframe->getPathway();
		$document	=& JFactory::getDocument();
		$model		=& $this->getModel();
		$user		=& JFactory::getUser();
		$uri     	=& JFactory::getURI();

		// Make sure you are logged in and have the necessary access rights
		if ($user->get('gid') < 19) {
			JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
			return;
		}

		//get the simplylink
		$simplylink	=& $this->get('data');
		$isNew	= ($simplylink->id < 1);

		// Edit or Create?
		if (!$isNew)
		{
			// Is this link checked out?  If not by me fail
			//if ($model->isCheckedOut($user->get('id'))) {
			//	$mainframe->redirect("index.php?option=$option", "The simplylink $simplylink->title is currently being edited by another administrator.");
			//}

			// Set page title
			$document->setTitle(JText::_('Links').' - '.JText::_('Edit'));

			//set breadcrumbs
			if($item->query['view'] != 'simplylink')
			{
				switch ($item->query['view'])
				{
					case 'categories':
						$pathway->addItem($simplylink->category, 'index.php?view=category&id='.$simplylink->catid);
						$pathway->addItem(JText::_('Edit').' '.$simplylink->title, '');
						break;
					case 'category':
						$pathway->addItem(JText::_('Edit').' '.$simplylink->title, '');
						break;
				}
			}
		}
		else
		{
			/*
			 * The simply link does not already exist so we are creating a new one.  Here
			 * we want to manipulate the pathway and pagetitle to indicate this.  Also,
			 * we need to initialize some values.
			 */
			$simplylink->published = 0;
			$simplylink->approved = 1;
			$simplylink->ordering = 0;

			// Set page title
			$document->setTitle(JText::_('Links').' - '.JText::_('New'));

			// Add pathway item
			$pathway->addItem(JText::_('New'), '');
		}

		// build list of categories
		$lists['catid'] = JHTML::_('list.category', 'jform[catid]', 'com_simplylinks', intval($simplylink->catid));

		// build the html select list for ordering
		$query = 'SELECT ordering AS value, title AS text'
			. ' FROM #__simplylinks'
			. ' WHERE catid = ' . (int) $simplylink->catid
			. ' ORDER BY ordering';

		$lists['ordering'] 			= JHTML::_('list.specificordering',  'jform[ordering]', $simplylink->id, $query, 1 );

		// Radio Buttons: Should the article be published
		$lists['published'] 		= JHTML::_('select.booleanlist',  'jform[published]', 'class="inputbox"', $simplylink->published );

		JFilterOutput::objectHTMLSafe( $simplylink, ENT_QUOTES, 'description' );

		$this->assign('action', 	$uri->toString());

		$this->assignRef('lists'   , $lists);
		$this->assignRef('simplylink' , $simplylink);

		parent::display($tpl);
	}
}
?>